
% Solves part b for three values of p: 0.1, 0.3, 0.5, and 0.8.
% To solve for other values of p, just change the 
% numbers in the vector p below.

% April 11, 1999
% Developed by Ali H. Sayed


clear
N=10;

p=[0.1 0.3 0.5 0.8];
L=length(p);
v=randn(N,1);


for j=1:L
 x=psk(p(j));
 y = x + v;
 z=cumsum(y);
 for i=1:N
   xopt(j,i)=tanh(0.5*log(p(j)/(1-p(j)))+z(i));
 end
end


clf;



subplot(221);
stem(xopt(1,:),'filled');
title('p=0.1');
xlabel('N');
grid
axis tight;
axis([1 10 -2 2]);

subplot(222);
stem(xopt(2,:),'filled');
title('p=0.3');
xlabel('N');
grid
axis tight;
axis([1 10 -2 2]);

subplot(223);
stem(xopt(3,:),'filled');
title('p=0.5');
xlabel('N');
grid
axis tight;
axis([1 10 -2 2]);

subplot(224);
stem(xopt(4,:),'filled');
title('p=0.8');
xlabel('N');
grid
axis tight;
axis([1 10 -2 2]);

