
% Solves part c for the value p=0.1, 0.3, 0.5, 0.8
% To solve for other values of p, just change 
% the numbers in the vector below.

% April 11, 1999
% Developed by Ali H. Sayed


clear

N=300;

p=[0.1 0.3 0.5 0.8];

L=length(p);

for j=1:L
 x=psk(p(j));
 y=x+randn(N,1);
 z=cumsum(y);
 for i=1:N
   xopt(j,i)=tanh(0.5*log(p(j)/(1-p(j)))+z(i));
   xavg(j,i)=z(i)/i;
 end
end


clf;

ind=1:N;

subplot(221);
plot(ind,xopt(1,:),'r',ind,xavg(1,:),'b');
title('p=0.1');
xlabel('N');
grid

subplot(222);
plot(ind,xopt(2,:),'r',ind,xavg(2,:),'b');
title('p=0.3');
xlabel('N');
grid

subplot(223);
plot(ind,xopt(3,:),'r',ind,xavg(3,:),'b');
title('p=0.5');
xlabel('N');
grid

subplot(224);
plot(ind,xopt(4,:),'r',ind,xavg(4,:),'b');
title('p=0.8');
xlabel('N');
grid
