
% Solves part D

% May 4, 1999
% Developed by Ali H. Sayed

close all
clear all;


M=4;                 % Number of antennas
M2=25;               % Another number of antennas

d_over_lambda= 1/5;  %ratio d/lambda


N=1000;      % Number of data points

var_v=0.2;              % variance of white noise
s=ones(1,N);         % Input is s(t)=constant;

v=sqrt(var_v/2)*randn(M,N)+i*sqrt(var_v/2)*randn(M,N);  
     % M complex noise vectors:
     % one for each antenna


v2=sqrt(var_v/2)*randn(M2,N)+i*sqrt(var_v/2)*randn(M2,N);  
     % M2 complex noise vectors:
     % one for each antenna

R_v = var_v*eye(M,M);
IR_v= inv(R_v);


R_v2 = var_v*eye(M2,M2);
IR_v2= inv(R_v2);


p_30=zeros(M,1);
p_302=zeros(M2,1);

  % Direction vector for 30^o
for j=1:M
   p_30(j)=exp((j-1)*i*2*pi*d_over_lambda*cos(pi/6));
end


  % Direction vector for 30^o
for j=1:M2
   p_302(j)=exp((j-1)*i*2*pi*d_over_lambda*cos(pi/6));
end


mmse = 1/((p_30)'*IR_v*(p_30));
Ko = p_30'*IR_v*mmse;      % Optimal gain vector


mmse2 = 1/((p_302)'*IR_v2*(p_302));
Ko2 = p_302'*IR_v2*mmse2;      % Optimal gain vector


%%% Create different direction vectors

iter=0;

display('PLEASE WAIT FOR 180 ITERATIONS')


gain=zeros(1,180);
gain2=zeros(1,180);

for dtheta=1:1:180

  theta=dtheta*pi/180;     % Angle in radians

  iter=iter+1

  p=zeros(M,1);
  y=zeros(M,N);
  p2=zeros(M2,1);
  y2=zeros(M2,N);


 for j=1:M
   p(j)=exp((j-1)*i*2*pi*d_over_lambda*cos(theta));
 end

 for j=1:M2
   p2(j)=exp((j-1)*i*2*pi*d_over_lambda*cos(theta));
 end

 for j=1:N
   y(:,j)  = p*s(j)+v(:,j);
   s_hat(j)= real(Ko*y(:,j));

   y2(:,j)  = p2*s(j)+v2(:,j);
   s_hat2(j)= real(Ko2*y2(:,j));
 end

 est_norm=norm(s_hat);
 gain(iter)=(est_norm*est_norm)/N;      % Power gain
 
 est_norm2=norm(s_hat2);
 gain2(iter)=(est_norm2*est_norm2)/N;   % Power gain
 
end



%%%%%%%%%% 4 antennas

g=10*log10(gain);  % in dB
g=g-min(g);        % Subtracts the least value
                   % We get a plot of dB gain relative to the smallest
                   % one.

polar([1:1:180]*pi/180,g);

%%%%%%%%% 25 antennas

g2=10*log10(gain2);  % in dB
g2=g2-min(g2);       % Subtracts the least value
                     % We get a plot of dB gain relative to the smallest
                     % one.

figure
polar([1:1:180]*pi/180,g2);

