
% This function takes a complex input value x and 
% returns the closest symbol to it from a QPSK
% constellation. That is, it implements the nonlinear
% decision device.

% Developed by A. H. Sayed
% April 28, 1999



function s=dec(x)

       a=sign(real(x));
       if a == 0  
         a=1;
       end

       b=sign(imag(x));
       if b == 0  
         b=1;
       end

       sq2=sqrt(2)/2;
       s=sq2*(a+i*b);  % output of nonlinear device

