
% Solves part B

% April 28, 1999
% Developed by Ali H. Sayed


clear;
clf;



c=[0.5 1.2 1.5 -1];  % Channel coefficients


var_v=0.078;        % variance of noise; CAN BE CHANGED
N=2000;           % number of symbols to be generated


s=(sign(randn(1,N))+i*sign(randn(1,N)))/(sqrt(2));
                              % generates QPSK data
y=filter(c,1,s);              % Filters the data through the channel

y=y+sqrt(var_v/2)*randn(1,N)+sqrt(var_v/2)*i*randn(1,N); 
                              % adds complex noise to it


%%%% We now plot all symbols in constellation 
%%%% form for both the transmitted and received signals

subplot(221);
plot(s,'x');grid;
title('Transmitted sequence');

subplot(222);
plot(y,'.');grid;
title('Received sequence');

