
% Solves part (a). The value of gamma and the 
% variance of u, denoted by var_u, can be changed.


% January 14, 2000
% Developed by Ali H. Sayed


clear all
close all

gamma=1;     % value of gamma
var_u=0.5;   % variance of u

display('Global minima at');

w_min_1= sqrt(gamma/(3*var_u))   % One global minimum
w_min_2=-sqrt(gamma/(3*var_u))   % The other global minimum
display('and minimum cost')
J_min = gamma^2 - (2*gamma*var_u)*w_min_1^2 + (3*var_u*var_u)*w_min_1^4

w=1.5*w_min_2:0.001:1.5*w_min_1;     % Interval and cost
J = gamma^2 - (2*gamma*var_u)*w.^2 + (3*var_u*var_u)*w.^4;

figure
subplot(221)
plot(w,J);
xlabel('w');
ylabel('J(w)');
grid
axis tight