

%% This program solves part D. It allows user to change 
%% value of gamma and the value of the initial weight estimate

%% Written by A. H. Sayed
%% Jan. 18, 2000

clear all
close all

gamma=1;

Ru= [1 0
     0 2];


w1o= [-1:0.01:1];  % range of values for grid
w2o= [-1:0.01:1]';
L = length(w1o);

J=zeros(L,L);
for i=1:L
 for j=1:L
  w=[w1o(i) w2o(j)]'; 
  x=w1o(i)^2;
  y=w2o(j)^2;
  c=x+2*y;
  J(j,i)=gamma*gamma + 2*c*c - 2*gamma*c;
 end
end    

% 3D plot of the cost function

figure
mesh(w1o, w2o, J);
title('3D plot of J(w)')
xlabel('\alpha');
ylabel('\beta');
view([-70 15]);

%subplot(222)
%mesh(w1o, w2o, J);
%title('A magnified view of the central part of J(w)');
%xlabel('\alpha');
%ylabel('\beta');
%view([-85 35]);
%axis([-1 1 -1 1 0.5 2])



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


N=1000;
we=zeros(2,N);
Je=zeros(1,N);
w_init = [1 -0.25]';   % First initial condition

w=w_init;
Je(1)= gamma^2 - 2*gamma*(w(1)^2+2*w(2)^2) + 2*(w(1)^2+2*w(2)^2)^2;
we(:,1)=w;
mu = 0.02;

for i = 2:N,
  w = w + mu*(gamma-2*w(1)^2-4*w(2)^2)*[w(1) 2*w(2)]';
  Je(i)=gamma^2 - 2*gamma*(w(1)^2+2*w(2)^2) + 2*(w(1)^2+2*w(2)^2)^2;

  we(:,i)=w;  
end;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

we2=zeros(2,N);
Je2=zeros(1,N);
w_init = [-1 0.25]';   %Second initial condition

w2=w_init;
Je2(1)= gamma^2 - 2*gamma*(w2(1)^2+2*w2(2)^2) + 2*(w2(1)^2+2*w2(2)^2)^2;
we2(:,1)=w2;
mu = 0.02;

for i = 2:N,
  w2 = w2 + mu*(gamma-2*w2(1)^2-4*w2(2)^2)*[w2(1) 2*w2(2)]';
  Je2(i)=gamma^2 - 2*gamma*(w2(1)^2+2*w2(2)^2) + 2*(w2(1)^2+2*w2(2)^2)^2;
  we2(:,i)=w2;  
end;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



%display('Wait for 3 minutes');
%contour(w1o, w2o, J, Je)  % This takes a LONG time (~3 minutes). 
                           % If you want to use it, comment the 
                           % three lines below.


min_J=min(min(J));   % minimum cost
max_J=max(max(J));   
levels=[min_J+0.00:0.05:1,1,1:2:max_J];

figure
contour(w1o, w2o,J,levels);
colorbar;
xlabel('\alpha_i');
ylabel('\beta_i');
s = strcat('Contour curves and trajectory for \mu = ', num2str(mu));
title(s);
hold on
plot(we(1,:), we(2,:),'xr--');
plot(we2(1,:), we2(2,:),'xm--');
hold off
zoom on

