
% Adaptive line echo canceller

% Solves parts B and C.

% Written by Ali H. Sayed 
% Mar. 2002


close all
clear all       % clears all variables

load path.mat;  % loads the echo path model
load css.mat;   % loads the CSS data


figure
subplot(221)
plot(css)
xlabel('i');
axis tight
title('CSS');
grid
subplot(222)
[P,F]=psd(css,256,8000); % 1 in x-axis corresponds to Fs/2
plot(F,10*log10(abs(P)))
ylabel('dB');
xlabel('Hz');
axis tight
title('Spectrum');
grid;

far_end=[];
for i=1:5
    far_end = [far_end css];
end
echo = filter(path,1,far_end);

N = length(far_end);
Pin  = 10*log10((norm(far_end)^2/N))
Pout = 10*log10((norm(echo)^2)/N)
ERL  = Pout - Pin

subplot(223)
plot(far_end)
title('Far-end');
xlabel('i');
axis([1 28000 -5 5]);
grid
subplot(224)
plot(echo)
title('Echo')
xlabel('i');
axis([1 28000 -5 5]);
grid