
% Adaptive Line Echo Canceller
% Solves part F

% Written by Ali H. Sayed 
% Mar. 2002


close all
clear all       % clears all variables


load path.mat;  % loads the echo path model
load css.mat;   % loads the CSS data

far_end_unit_power = [];
for i=1:80
    far_end_unit_power = [far_end_unit_power css];
end

N = length(far_end_unit_power);

M=128; 
mu = 0.25; % step-size for e-NLMS
epsilon = 1e-6;
var_n = 0.0001;
sqn = sqrt(var_n);

powerdb = 0;
power = 10^(powerdb/10); 
far_end = far_end_unit_power*sqrt(power); 
echo = filter(path,1,far_end);
echo = echo + sqn*randn(1,N);

w = zeros(M,1); % weight estimate
u = zeros(1,M); % regressor

disp('Please wait for a while...')

for i=1:N
  u = [far_end(i) u(1:M-1)];
  e(i) = echo(i) - u*w;
  factor = epsilon + (norm(u)^2);
  w = w + (mu/factor)*u'*e(i);  % e-NLMS
  if mod(i,5000)==0
      i
  end
end


 Pecho  = 10*log10((norm(echo(N-5600:N))^2/5600));
 Perror = 10*log10((norm(e(N-5600:N))^2)/5600); % power of error by simulation
 ERLE_sim  = Pecho - Perror; % by simulation


 MSE = var_n + ((mu*var_n)/(2-mu));
 MSE = 10*log10(MSE); % power of error by theory;
 
 ERLE_thy = Pecho - MSE;
 
 [ERLE_sim ERLE_thy]